<?php

/**
 * PayStar Gateway for Easy Donations
 * 
 */

add_action( 'plugins_loaded', 'run_edt_ps_gateway' );

function run_edt_ps_gateway()
{
	if( ! class_exists( 'EDT_paystar_Gateway' ) && class_exists( 'Easy_Donations_Gateway' ) )
	{
		class EDT_paystar_Gateway extends Easy_Donations_Gateway
		{

			const version = '1.0';

			public function __construct()
			{
			}

			public function gateway_settings_fields()
			{
				$gateway_id = 'edt_ps_gateway';
				$gtw_data = edt_ins()->options->get_option( $gateway_id );
				$setting_fields = array(array(
						'id'      => 'paystar_terminal',
						'name'    => '[paystar_terminal]',
						'type'    => 'text',
						'text'    => 'ترمینال درگاه پی استار را وارد نمایید.',
						'value'   => ( isset( $gtw_data['paystar_terminal'] ) ) ? $gtw_data['paystar_terminal'] : ''
					));
				$this->add_gtw_setting( $gateway_id, 'پی استار', $setting_fields );
			}

			public function before_send( $payment )
			{
				$gtw_data = edt_ins()->options->get_option( 'edt_ps_gateway' );
				$active_currency = edt_ins()->options->get_option( 'donate_form_active_currency' );
				if( $active_currency['Code'] == 'IRT' ) $payment['amount'] = $payment['amount'] * 10;
				require_once(dirname(__FILE__) . '/paystar_payment_helper.class.php');
				$p = new PayStar_Payment_Helper($gtw_data['paystar_terminal']);
				$r = $p->paymentRequest(array(
						'amount'   => intval(ceil($payment['amount'])),
						'order_id' => $payment['id'],
						'callback' => add_query_arg( array( 'listener' => 'paystar-easy-donations', 'pay_id' => $payment['id'], 'shf_key' => session_id() ), get_site_url().'/' )
					));
				if ($r)
				{
					$_SESSION['paystar_edt_id'] = $payment['id'];
					$p->redirect();
				}
				else
				{
					$this->add_message( 'خطا در اتصال به پی استار : ' . $p->error, 'error' );
					edt_ins()->payment->complete_payment( $payment, 'failed' );
					header( "location: " . $payment['pay_url'] );        
				}
				die();
			}

			public function on_return( $payment, $post )
			{
				$gtw_data = edt_ins()->options->get_option( 'edt_ps_gateway' );
				$amount = $payment['amount'];
				$active_currency = edt_ins()->options->get_option( 'donate_form_active_currency' );
				if( $active_currency['Code'] == 'IRT' ) $amount = $amount * 10;
				require_once(dirname(__FILE__) . '/paystar_payment_helper.class.php');
				$p = new PayStar_Payment_Helper($gtw_data['paystar_terminal']);
				$r = $p->paymentVerify(array_merge($_POST, array('amount' => intval(ceil($amount)))));
				if ($r)
				{
					$this->add_message( 'پرداخت شما با موفقیت دریافت شد. شماره پیگیری : '.$p->txn_id, 'updated' );
					edt_ins()->payment->complete_payment( $payment, 'completed', $p->txn_id );
				}
				else
				{
					$this->add_message( 'خطا در بازگشت از عملیات پرداخت ( '.$p->error.' )', 'error' );
					edt_ins()->payment->complete_payment( $payment, 'failed' );
				}
				header( "location: " . $payment['pay_url'] );
				die();
			}

		}

		edt_ins()->gateways->register_gateway( 'edt_ps_gateway', 'پی استار', 'EDT_paystar_Gateway' );

	}

}
